diff mbox

[v2,2/2] overlay: copy-up lowerdir which has opaque xattr set

Message ID 1470741381-32610-2-git-send-email-eguan@redhat.com (mailing list archive)
State New, archived
Headers show

Commit Message

Eryu Guan Aug. 9, 2016, 11:16 a.m. UTC
When copying up a directory with opaque xattr set, the xattr was
copied up as well, after a remount the opaque flag is honored so the
copied-up directory is treated as opaque, which causes files created
in the lowerdir to be hidden when using multiple lower directories.

This is fixed by "ovl: don't copy up opaqueness".

Signed-off-by: Eryu Guan <eguan@redhat.com>
---
v2:
- use _overlay_mount_dirs helper to do the overlay mount
- use _scratch_unmount instead of raw $UMOUNT_PROG
- remove unused _require_attrs

 tests/overlay/014     | 92 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/overlay/014.out |  3 ++
 tests/overlay/group   |  1 +
 3 files changed, 96 insertions(+)
 create mode 100755 tests/overlay/014
 create mode 100644 tests/overlay/014.out

Comments

Dave Chinner Sept. 1, 2016, 12:22 a.m. UTC | #1
On Tue, Aug 09, 2016 at 07:16:21PM +0800, Eryu Guan wrote:
> When copying up a directory with opaque xattr set, the xattr was
> copied up as well, after a remount the opaque flag is honored so the
> copied-up directory is treated as opaque, which causes files created
> in the lowerdir to be hidden when using multiple lower directories.
> 
> This is fixed by "ovl: don't copy up opaqueness".
....
> +_scratch_mkfs
> +
> +# Create multiple lowerdirs and upperdir, workdir, and testdir on lowerdir
> +lowerdir1=$SCRATCH_DEV/lower1
> +lowerdir2=$SCRATCH_DEV/lower2
> +upperdir=$SCRATCH_DEV/upper
> +workdir=$SCRATCH_DEV/workdir
> +mkdir -p $lowerdir1 $lowerdir2 $upperdir $workdir
> +mkdir -p $lowerdir1/testdir/d
> +
> +# mount overlay with $lowerdir2 as upperdir, and remove & recreate testdir,
> +# make testdir on $lowerdir2 opaque
> +_overlay_mount_dirs $lowerdir1 $lowerdir2 $workdir none $SCRATCH_MNT

What is the "none" here? If _overlay_mount_dirs() doesn't require
this parameter to have a specifically valid value, then why are
we passing it in at all?

Cheers,

Dave.
Eryu Guan Sept. 1, 2016, 3:56 a.m. UTC | #2
On Thu, Sep 01, 2016 at 10:22:41AM +1000, Dave Chinner wrote:
> On Tue, Aug 09, 2016 at 07:16:21PM +0800, Eryu Guan wrote:
> > When copying up a directory with opaque xattr set, the xattr was
> > copied up as well, after a remount the opaque flag is honored so the
> > copied-up directory is treated as opaque, which causes files created
> > in the lowerdir to be hidden when using multiple lower directories.
> > 
> > This is fixed by "ovl: don't copy up opaqueness".
> ....
> > +_scratch_mkfs
> > +
> > +# Create multiple lowerdirs and upperdir, workdir, and testdir on lowerdir
> > +lowerdir1=$SCRATCH_DEV/lower1
> > +lowerdir2=$SCRATCH_DEV/lower2
> > +upperdir=$SCRATCH_DEV/upper
> > +workdir=$SCRATCH_DEV/workdir
> > +mkdir -p $lowerdir1 $lowerdir2 $upperdir $workdir
> > +mkdir -p $lowerdir1/testdir/d
> > +
> > +# mount overlay with $lowerdir2 as upperdir, and remove & recreate testdir,
> > +# make testdir on $lowerdir2 opaque
> > +_overlay_mount_dirs $lowerdir1 $lowerdir2 $workdir none $SCRATCH_MNT
> 
> What is the "none" here? If _overlay_mount_dirs() doesn't require
> this parameter to have a specifically valid value, then why are
> we passing it in at all?

It's place-holder for device to be mounted, for overlayfs this can be
any string but cannot be omitted. I probably should use $SCRATCH_DEV
instead, like what _scratch_mount does on overlayfs, so helpers like
_fs_type and _df_device that look for mounted device could work
correctly.

Thanks for the review!

Eryu
--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
diff mbox

Patch

diff --git a/tests/overlay/014 b/tests/overlay/014
new file mode 100755
index 0000000..510f0cd
--- /dev/null
+++ b/tests/overlay/014
@@ -0,0 +1,92 @@ 
+#! /bin/bash
+# FS QA Test 014
+#
+# Test copy-up of lowerdir with opaque xattr set.
+#
+# When copying up a directory with opaque xattr set, the xattr was copied up as
+# well, after a remount the opaque flag is honored so the copied-up directory
+# is treated as opaque, which causes files created in the lowerdir to be hidden
+# when using multiple lower directories.
+#
+# This is fixed by "ovl: don't copy up opaqueness".
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Red Hat Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs overlay
+_supported_os Linux
+_require_test
+_require_scratch
+
+# Remove all files from previous tests
+_scratch_mkfs
+
+# Create multiple lowerdirs and upperdir, workdir, and testdir on lowerdir
+lowerdir1=$SCRATCH_DEV/lower1
+lowerdir2=$SCRATCH_DEV/lower2
+upperdir=$SCRATCH_DEV/upper
+workdir=$SCRATCH_DEV/workdir
+mkdir -p $lowerdir1 $lowerdir2 $upperdir $workdir
+mkdir -p $lowerdir1/testdir/d
+
+# mount overlay with $lowerdir2 as upperdir, and remove & recreate testdir,
+# make testdir on $lowerdir2 opaque
+_overlay_mount_dirs $lowerdir1 $lowerdir2 $workdir none $SCRATCH_MNT
+rm -rf $SCRATCH_MNT/testdir
+mkdir -p $SCRATCH_MNT/testdir/visibledir
+_scratch_unmount
+
+# mount overlay again, with lowerdir1 and lowerdir2 as multiple lowerdirs,
+# and create a new file in testdir, triggers copyup from lowerdir,
+# copyup should not copy overlayfs private xattr
+_overlay_mount_dirs "$lowerdir2:$lowerdir1" $upperdir $workdir none $SCRATCH_MNT
+touch $SCRATCH_MNT/testdir/visiblefile
+
+# umount and mount overlay again, buggy kernel treats the copied-up dir as
+# opaque, visibledir is not seen in merged dir.
+_scratch_unmount
+_overlay_mount_dirs "$lowerdir2:$lowerdir1" $upperdir $workdir none $SCRATCH_MNT
+ls $SCRATCH_MNT/testdir
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/014.out b/tests/overlay/014.out
new file mode 100644
index 0000000..ec09c4d
--- /dev/null
+++ b/tests/overlay/014.out
@@ -0,0 +1,3 @@ 
+QA output created by 014
+visibledir
+visiblefile
diff --git a/tests/overlay/group b/tests/overlay/group
index 5c80566..71eaadb 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -16,3 +16,4 @@ 
 011 auto quick
 012 auto quick
 013 auto quick
+014 auto quick copyup